using System;
using System.Collections.Generic;
using System.Text;
using System.Data;
using System.Diagnostics;
using System.ComponentModel;

namespace HelpLibrary
{
    [DefaultEvent("Click")]
    public class HelpButtonDB : HelpButton
    {
        private System.ComponentModel.IContainer components;

        public HelpButtonDB() : base()
        {
            InitializeComponent();
        }
    
        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // HelpButtonDB
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.HelpString = "";
            this.Name = "HelpButtonDB";
            this.Load += new System.EventHandler(this.HelpButtonDB_Load);
            this.ResumeLayout(false);

        }

        private static HelpButtonDB btnCurrent = null;
        public static HelpButtonDB ButtonCurrent
        {
            get { return btnCurrent; }
        }

        public override void buttonHelp_MouseEnter(object sender, EventArgs e)
        {
            btnCurrent = this;
            String key = String.Format("{0}.{1}",this.Parent.GetType(), this.Name);
            int index = this.DisplayBox.helpInfoBindingSource.Find("Name", key);
            if (index > -1)
            {
                this.DisplayBox.helpInfoBindingSource.Position = index;
            }
            else
            {
                DataRowView view = (DataRowView)
                    this.DisplayBox.helpInfoBindingSource.AddNew();
                Debug.Assert(key != null && key.Length > 0);
                view["Name"] = key;
                view["HelpString"] = this.HelpString;
                this.DisplayBox.helpInfoBindingSource.ResetCurrentItem();                
            }
            //Do not need to set the help string, which would update the
            //text box, since the text box is bound to the DB
            //base.buttonHelp_MouseEnter(sender, e);
        }

        private void HelpButtonDB_Load(object sender, EventArgs e)
        {
            
        } 
    }
}
