using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Design;

namespace HelpLibrary
{
    public partial class TextHelpBox : UserControl
    {
        public TextHelpBox()
        {
            InitializeComponent();
        }

        private void fontToolStripMenuItem_Click(object sender, EventArgs e)
        {
            using (FontDialog dlg = new FontDialog())
            {
                dlg.Font = textBoxHelp.Font;
                if (DialogResult.OK == dlg.ShowDialog())
                {
                    textBoxHelp.Font = dlg.Font;
                }
            }
        }

        [Category("Help")]
        [Description("Help string to show in text box.")]
        [Editor(typeof(HelpEditor), typeof(UITypeEditor))]
        public String HelpString
        {
            get { return this.textBoxHelp.Text; }
            set { this.textBoxHelp.Text = value; }
        }

        private int nPointSize = 12;
        private void textBoxHelp_MouseDown(object sender, MouseEventArgs e)
        {
            if (bCtrl)
            {
                int nIncr = 0;
                switch (e.Button)
                {
                    case MouseButtons.Left:
                        nIncr = 2;
                        break;
                    case MouseButtons.Right:
                        nIncr = -2;
                        break;
                }
                nPointSize += nIncr;
                if (nPointSize < 12) nPointSize = 12;
                else if (nPointSize > 18) nPointSize = 18;
                textBoxHelp.Font = new Font(textBoxHelp.Font.FontFamily, nPointSize);
            }
        }

        bool bCtrl = false;
        private void textBoxHelp_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Control)
            {
                bCtrl = false;
            }
        }

        private void textBoxHelp_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Control)
            {
                bCtrl = true;
            }
        }

        private void fontToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            using (FontDialog dlg = new FontDialog())
            {
                dlg.Font = textBoxHelp.Font;
                if (dlg.ShowDialog() == DialogResult.OK)
                {
                    textBoxHelp.Font = dlg.Font;
                }
            }
        }

        private void textBoxHelp_Validating(object sender, CancelEventArgs e)
        {
            if (bNeedUpdate)
            {
                bNeedUpdate = false;
                helpInfoBindingSource.EndEdit();                    
                helpInfoTableAdapter.Update(this.helpInfoDataSet.HelpInfo);
            }
        }

        private void TextHelpBox_Load(object sender, EventArgs e)
        {
            if (!this.DesignMode)
            {
                String domain = (String) AppDomain.CurrentDomain.GetData("DataDirectory");
                AppDomain.CurrentDomain.SetData("DataDirectory", @"\cop4226\0801\HelpLibrary");
                helpInfoTableAdapter.Connection.ConnectionString = 
                    @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=..\..\helpInfo.mdb";
                //Console.Out.WriteLine(this.helpInfoTableAdapter.Connection.ConnectionString);
                //this.helpInfoTableAdapter.Connection. = "|DataDirectory|\\helpinfo.mdb";
                this.helpInfoTableAdapter.Fill(this.helpInfoDataSet.HelpInfo);
                //AppDomain.CurrentDomain.SetData("DataDirectory", domain);
            }
        }

        bool bNeedUpdate = false;
        private void textBoxHelp_TextChanged(object sender, EventArgs e)
        {
            bNeedUpdate = true;
        }

        private void textBoxHelp_ModifiedChanged(object sender, EventArgs e)
        {
            
        }

        private void textBoxHelp_Enter(object sender, EventArgs e)
        {
            
        }
    }
}